> For the complete documentation index, see [llms.txt](https://docs-v3.toucantoco.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs-v3.toucantoco.com/tutorials/advanced-tutorials/embed-a-story-with-user-attributes/dynamic-filter-with-user-attributes.md).

# Dynamic filter with user attributes

To refine your dataset based on specific user attributes, incorporate these attributes directly in the SQL query. This can be particularly useful for personalizing data retrieval or implementing access controls.

**How to Implement:**

* First, switch to SQL code mode in your database tool or SQL editor.
* Next, locate the WHERE clause of your query. This is where you'll add the conditions based on user attributes.
* Insert the user attribute condition. For example, if you want to filter data for a specific country, you might add:

  ```sql
  Where country = '{{ (user or {}).get('attributes', {}).get('country', 'Belgium') }}'
  ```

Example Query:

```sql
SELECT * FROM "breezy"."deals_breezy"
Where country = '{{ (user or {}).get('attributes', {}).get('country', 'Belgium') }}'
```

In this example, we're filtering users based on the country attribute. This method leverages conditional logic to either use the `country` attribute or default to `'Belgium'` if the attribute doesn't exist.

{% @arcade/embed url="<https://app.arcade.software/share/Nibd6cFXviE4lY4n6XY8>" flowId="Nibd6cFXviE4lY4n6XY8" %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs-v3.toucantoco.com/tutorials/advanced-tutorials/embed-a-story-with-user-attributes/dynamic-filter-with-user-attributes.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
